package tagging

import (
	"context"
	"testing"

	"github.com/stretchr/testify/require"
)

func TestContext(t *testing.T) {
	ctx := context.Background()
	tag, ok := IOTagFromContext(ctx)
	require.False(t, ok)
	require.Equal(t, "", tag)
	ctx = ContextWithIOTag(ctx, "tag1")
	tag, ok = IOTagFromContext(ctx)
	require.True(t, ok)
	require.Equal(t, "tag1", tag)
	ctx = ContextWithIOTag(ctx, "tag2")
	tag, ok = IOTagFromContext(ctx)
	require.True(t, ok)
	require.Equal(t, "tag2", tag)
}
